// Code generated by go generate. DO NOT EDIT.

package opt

import "encoding/json"

// SafeOption is a wrapper for an Safe option parameter. It holds
// the actual value of the option that can be accessed by calling Get.
type SafeOption struct {
	value bool
}

// Safe wraps the given value into a SafeOption.
func Safe(v bool) *SafeOption {
	return &SafeOption{v}
}

// Get retrieves the actual value of the option parameter.
func (o *SafeOption) Get() bool {
	if o == nil {
		return false
	}
	return o.value
}

// MarshalJSON implements the json.Marshaler interface for
// SafeOption.
func (o SafeOption) MarshalJSON() ([]byte, error) {
	return json.Marshal(o.value)
}

// UnmarshalJSON implements the json.Unmarshaler interface for
// SafeOption.
func (o *SafeOption) UnmarshalJSON(data []byte) error {
	if string(data) == "null" {
		o.value = false
		return nil
	}
	return json.Unmarshal(data, &o.value)
}

// Equal returns true if the given option is equal to the instance one. In case
// the given option is nil, we checked the instance one is set to the default
// value of the option.
func (o *SafeOption) Equal(o2 *SafeOption) bool {
	if o == nil {
		return o2 == nil || o2.value == false
	}
	if o2 == nil {
		return o == nil || o.value == false
	}
	return o.value == o2.value
}

// SafeEqual returns true if the two options are equal.
// In case of one option being nil, the value of the other must be nil as well
// or be set to the default value of this option.
func SafeEqual(o1, o2 *SafeOption) bool {
	return o1.Equal(o2)
}
